
/***************************************************************************
  03 April 1996 10:11
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:   Many People including:

  Gregory A. Baker, Center for Space Research,
  University of Texas at Austin  78722      baker@csr.utexas.edu

  Philip A. Alpatov, Department of Physics,
  University of Texas at Austin 78712.     philip@physics.utexas.edu

  James Overfelt, Department of Mathematics,
  University of Texas at Austin  78712.    overfelt@@math.utexas.edu
  
  John Andrew Gunnels, Department of Computer Sciences,
  University of Texas at Austin 78712.     gunnels@@cs.utexas.edu
  
  Greg Morrow, Department of Physics, 
  University of Texas at Austin 78712.     morrow@@physics.utexas.edu
 
  Dr. Robert Van de Geijn, Department of Computer Sciences,
  University of Texas at Austin 78712.     rvdg@@cs.utexas.edu
 
***************************************************************************/

#include "PLA.h"

int PLA_Show(PLA_Obj laobj)
{
  int
    i,np, me;
  
  PLA_Template 
    template;


  PLA_Obj_template(laobj, &template);
  PLA_Temp_total_num_proc(template, &np);
  PLA_Temp_me1D( template, &me);
  
      MPI_Barrier(MPI_COMM_WORLD);

    for(i=0;i<np;i++)
    {
      if(me==i)
	{
	  printf("Data from node %d\n", i);
	  fflush( stdout );
          sleep(10); 
	  PLA_Print_laobj(laobj);  
	  fflush( stdout );
 printf("\n");
 sleep(10); 
	}
      MPI_Barrier(MPI_COMM_WORLD);
    }
  printf("\n");
  fflush( stdout );
  
  return(0);
}

int PLA_Show_obj(PLA_Obj laobj)
{
  int
    i,np, me;
  
  PLA_Template 
    template;


  PLA_Obj_template(laobj, &template);
  PLA_Temp_total_num_proc(template, &np);
  PLA_Temp_me1D( template, &me);
  
  MPI_Barrier(MPI_COMM_WORLD);

  printf ("node %d: =============================================\n",
        me);
  printf ("node %d: obj_type %d: annotate_flags %d %d\n",
        me,
        laobj->obj_type, 
        laobj->annotate_flags.panel_rowcol,
        laobj->annotate_flags.duplicate);
  printf ("node %d: views %d: master_buffer %p: length %d: buffer %p\n",
        me,
        *(laobj->views),
        laobj->master_buffer,
        laobj->length_master_buffer_byte,
        laobj->buffer);
  printf ("node %d: master_length %d: master_width %d: "
          "master_align_row %d: master_align_col %d\n",
        me,
        laobj->master_length,
        laobj->master_width,
        laobj->master_align_row,
        laobj->master_align_col);
  printf ("node %d: local-stride %d: local_lld %d: "
          "local_length %d: local_width %d\n",
        me,
        laobj->local_stride,
        laobj->local_lld,
        laobj->local_length,
        laobj->local_width);
  printf ("node %d: global_length %d: global_width %d:"
          "global_align_row %d: global_align_col %d\n",
        me,
        laobj->global_length,
        laobj->global_width,
        laobj->global_align_row,
        laobj->global_align_col);
  printf ("node %d: length_top_block %d: length_bottom_block %d:"
          "width_left_block %d: width_right_block %d\n",
        me,
        laobj->length_top_block,
        laobj->length_bottom_block,
        laobj->width_left_block,
        laobj->width_right_block);
  printf ("node %d: owner_top_block %d: owner_bottom_block %d:"
          "owner_left_block %d: owner_right_block %d\n",
        me,
        laobj->owner_top_block,
        laobj->owner_bottom_block,
        laobj->owner_left_block,
        laobj->owner_right_block);

  MPI_Barrier(MPI_COMM_WORLD);

  return(0);
}

