#include "PLA.h"

int PLA_MEMORY_ALLOC_COUNT = 0;

void * pla_malloc ( int size )
{
  void * ptr = NULL;
  char buffer [ 128 ], routine_name [ 128 ] = "pla_malloc";
  if ( ( ptr = malloc ( size ) ) == NULL )
  {
    sprintf ( buffer, "Memory allocation failed, %d bytes\n", size );
    PLA_Log_abort ( routine_name, buffer, PLA_ERROR_CODE, 0 );
  }
  else
    pla_memory_alloc_count ();
  return ( ptr );
}

void * pla_calloc ( int num, int size )
{
  void * ptr = NULL;
  char buffer [ 128 ], routine_name [ 128 ] = "pla_calloc";
  if ( ( ptr = calloc ( num, size ) ) == NULL )
  {
    sprintf ( buffer, "Memory allocation failed, %d bytes\n", size );
    PLA_Log_abort ( routine_name, buffer, PLA_ERROR_CODE, 0 );
  }
  else
    pla_memory_alloc_count ();
  return ( ptr );
}

void pla_free ( void * ptr )
{
  free ( ptr );
  pla_memory_free_count ();
  return;
}

int pla_memory_alloc_count ( void )
{
   extern int PLA_MEMORY_ALLOC_COUNT;
   PLA_MEMORY_ALLOC_COUNT++;
   return ( 0 );
}

int pla_memory_free_count ( void )
{
   extern int PLA_MEMORY_ALLOC_COUNT;
   PLA_MEMORY_ALLOC_COUNT--;
   if ( PLA_MEMORY_ALLOC_COUNT < 0 ) return ( 1 );
   return ( 0 );
}

int pla_alloc_count ( void )
{
   extern int PLA_MEMORY_ALLOC_COUNT;
   return ( PLA_MEMORY_ALLOC_COUNT );
}
