#include <mpi.h>
#include <PLA.h>
#include <MISC_DEFS.h>
#include "PRISM.h"

/* temporary - need to make this an argument */
extern nb;

void PRISM_find_subspaces(PLA_Obj X, PLA_Obj Q) {
/*
    Find the orthogonal transformations Q_1 and Q_2 that are
    put into Q. 
*/
    int           k, bnd = 1;
    double        resid;
    PLA_Obj       temp=NULL, star=NULL, X12=NULL;
    MPI_Datatype  datatype;
    PLA_Template  template;
    double        t_start;

    /* Extract info from matrix X */
    PLA_Obj_datatype          ( X, &datatype );
    PLA_Obj_template          ( X, &template );

    /* Temporary objects */
    PLA_Matrix_create_conf_to( X, &temp );

    /* Set Q to the identity */
    PRISM_set_to_ident(Q);

#ifdef DB_GLOBAL_
    if (me==ROOT) printf(">> PRISM_find_subspaces I\n");
    PRISM_print(X);
    PRISM_print(Q);
#endif

    /* PRISM_long_print(X);  */

    /* Reduce X to tridiagonal (ie, bnd = 1) */
    /*t_start = MPI_Wtime();*/
    prism_pla_sbndrd( X, Q, nb, bnd ); 
    /*t_syisda[t_sbr] += MPI_Wtime() - t_start;*/
#ifdef DB_GLOBAL_
    if (me==ROOT) printf(">> PRISM_find_subspaces II\n");
    PRISM_print(X);
    PRISM_print(Q);
#endif

    /* Solve tridiagonal system */
    prism_pla_trisvd(X, Q); 

    /* Free objects */
    PLA_Obj_free(&temp);
    PLA_Obj_free(&star); 
    PLA_Obj_free(&X12);

#ifdef DB_GLOBAL_
    if (me==ROOT) printf(">> PRISM_find_subspaces III\n");
    PRISM_print(X);
    PRISM_print(Q);
#endif

}

